<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Constructors</title>
</head>
<body>

  <div class="wrap" id="wrap">
    <header>
      <form>

        <label for="author">
          <span>Author</span>
          <select id="author" name="author">
            <option value="Taras Shevchenko">Taras Shevchenko</option>
            <option value="Ivan Franko">Ivan Franko</option>
            <option value="Vasyl Stys">Vasyl Stys</option>
            <option value="Oles Gonchar">Oles Gonchar</option>
          </select>
        </label>

        <label for="message">
          <span>Message</span>
          <textarea placeholder="Your Message" id="message"></textarea>
        </label>

        <button type="submit" id = "submit">Send Message</button>
      </form>
    </header>
    <div id="for_mess">
    </div>

   



  </div>


  <script>
  /*
    Задание на классы.

    Создать класс Message конструктор котрого состоит из следующих полей:
    id, author, text, date, answers

    У этого класса будет два метода:
    SkipMessage() -> которое должно найти сообщение и удалить его из массива.
    AnswerMessage()-> должно отрыть поле ввода, в который вы сможете ввести ответ
    SendAnswer() -> метод который «отравляет» ответ, при этом апдейча роле ответа в вашем объекте с сообщением.

    В метод SendAnswer нужно передать обьект класса Answer который наследуется от класса Message,
    Но еще дополнительно будет иметь поле parentId.


    +Bonus: После создании сообщение добавляется в массив со всеми сообщениями, которые потом будут выводится на экран.

    _ _ _

    Задание можно разбелить на две части:
      1. Создание самого сообщения:
      id->выдаётся автоматом
      Author-> селект с выбором автора
      Text -> текст сообщения
      date -> автоматически в момент создания

      Все данные беруться с формы. Массив с сообщениями передается в функцию рендера, которая генерирует сам список.

      2. Ответ на сообщение

  */
  let masssiv_massengers = [];
  let wrap = document.getElementById("wrap");
  let submit = document.getElementById("submit");
  let author_select = document.getElementById("author");
  let message_input = document.getElementById("message");
  let id = 0;
  let ans_id = 0;
  let message_div = document.getElementById("for_mess");

  class Message { 
    constructor(id, author, text, date, answers){
      this.id = id;
      this.author = author;
      this.text = text;
      this.date = date;
      this.answers = answers;
      this.SkipMessage = this.SkipMessage.bind(this);
      this.AnswerMessage = this.AnswerMessage.bind(this);
      this.SendAnswer = this.SendAnswer.bind(this);
      this.render = this.render.bind(this);
      //let ansDiv = "";
    }
    SkipMessage(){
      message_div.innerHTML = "";
      delete masssiv_massengers[this.id];
      masssiv_massengers.forEach( (item) => {
        let section = document.createElement("div");
        section.setAttribute("class","_sectionMess");
        message_div.appendChild(section);
          let html = `
            <ul id="message_list">
              <li>
                <div class="message__id">
                  Id: ${item.id}
                </div>
                <div class="message__date">
                  date: ${item.date}
                </div>
                <div class="message__author">
                  author: ${item.author}
                </div>
                <div class="message__text">
                  text: ${item.text}
                </div>
                <div class="message__controls">
                  <button class="_skipMessage" >Skip</button>
                  <button class="_answerMessage">Answer</button>
                </div>
                <div class="_formAnswer" id="fa_${this.id}"</div>
              </li>
              
            </ul>
            `;
        section.innerHTML = html;
        const btn = section.querySelector('._skipMessage');
        const btnAns = section.querySelector('._answerMessage');
        btn.addEventListener('click',item.SkipMessage );
        btnAns.addEventListener('click', item.AnswerMessage );
      })
    }
    AnswerMessage(){
      let ansDiv = document.getElementById("fa_"+this.id);;

      let htmlForm = `
       <textarea placeholder="Your Answer" class = "_answerText"></textarea>
       <button type="submit" class = "_answerBut">Send Answer</button>
    `;

      ansDiv.innerHTML = htmlForm;
      const ansBtn = ansDiv.querySelector("._answerBut");
      
      ansBtn.addEventListener("click", this.SendAnswer)
    }

    SendAnswer(){
        let ansDiv = document.getElementById("fa_"+this.id);
        console.log(ansDiv);
        const textAns = ansDiv.querySelector("._answerText");
        let text = textAns.value;
        ans_id++;
        let arr_mass = [];
        this.answers[ans_id] = new Answer (ans_id, this.author, text, new Date(), this.id, arr_mass);
        this.answers[ans_id].render();
    }

    render(){
      let section = document.createElement("div");
      section.setAttribute("class","_sectionMess");
      message_div.appendChild(section);
        let html = `
          <ul id="message_list">
            <li>
              <div class="message__id">
                Id: ${this.id}
              </div>
              <div class="message__date">
                date: ${this.date}
              </div>
              <div class="message__author">
                author: ${this.author}
              </div>
              <div class="message__text">
                text: ${this.text}
              </div>
              <div class="message__controls">
                <button class="_skipMessage" >Skip</button>
                <button class="_answerMessage">Answer</button>
              </div>
              <div id="fa_${this.id}" class="_formAnswer"</div>
            </li>
            
          </ul>
          `;
      section.innerHTML = html;
      const btn = section.querySelector('._skipMessage');
      const btnAns = section.querySelector('._answerMessage');
      btn.addEventListener('click',this.SkipMessage );
      btnAns.addEventListener('click', this.AnswerMessage );
      }
  }

  class Answer extends Message {
      constructor(id, author, text, date, parentId, answers){
        super(id, author, text, date, answers);
        this.parentId = parentId;
        this.AnswerMessage = this.AnswerMessage.bind(this);
        this.SendAnswer = this.SendAnswer.bind(this);
      }
      
      render(){
        let ansDiv = document.getElementById("fa_" + this.parentId);
        
          let html = `
            <ul id="message_list">
              <li>
                <div class="message__id">
                  Id: ${this.id}
                </div>
                <div class="message__id">
                  parentId: ${this.parentId}
                </div>
                <div class="message__date">
                  date: ${this.date}
                </div>
                <div class="message__author">
                  author: ${this.author}
                </div>
                <div class="message__text">
                  text: ${this.text}
                </div>
                <div class="message__controls">
                  <button class="_skipMessage" >Skip</button>
                  <button class="_answerMessage">Answer</button>
                </div>
                <div class="_formAnswer" id="fa_${this.id}"</div>
              </li>
              
            </ul>
            `;
        ansDiv.innerHTML = html;
        const btn = ansDiv.querySelector('._skipMessage');
        const btnAns = ansDiv.querySelector('._answerMessage');
        btn.addEventListener('click',this.SkipMessage );
        btnAns.addEventListener('click',this.AnswerMessage);
      }

      SkipAnswer(){
        let ansDiv = document.getElementById("fa_" + this.parentId);
        ansDiv.innerHTML = "";
      }
    }

  const createMessage = (e) => {

    e.preventDefault();
    let author = author_select.value;
    let message_text = message_input.value;
    id++;
    let date = new Date();
    let arr_mass = [];
    masssiv_massengers[id] = new Message(id,author,message_text,date,arr_mass);
    masssiv_massengers[id].render();
  }

  submit.addEventListener("click",createMessage);

  </script>
</body>
</html>
